﻿#region license
// Copyright (c) 2004, Rodrigo B. de Oliveira (rbo@acm.org)
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
// 
//     * Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//     * Neither the name of Rodrigo B. de Oliveira nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
// CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#endregion

import System
import System.Net
import System.IO
import System.Text.RegularExpressions

def read(stream as Stream):
	using reader=StreamReader(stream):
		return reader.ReadToEnd()

url = argv[0]
targetDir = "grab"
Directory.CreateDirectory(targetDir) unless Directory.Exists(targetDir)

client = WebClient()
downloadFile = client.DownloadFile

page = read(client.OpenRead(url))
for match as Match in /img\s+src\s*=\s*"(.+?)"/.Matches(page):
	src = match.Groups[1].ToString()
	local = Path.Combine(targetDir, Path.GetFileName(src))
	Console.Write("${src} => ${local}: ")
	handle = downloadFile.BeginInvoke(src, local, null, null)
	while not handle.IsCompleted:
		Console.Write(".")
		System.Threading.Thread.Sleep(50ms)
	Console.WriteLine()
	downloadFile.EndInvoke(handle)
	
	
	
